<?php

/**
 * inf_ven_consol_cliente actions.
 *
 * @package    cartera
 * @subpackage inf_nota_credito
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class res_consol_ven_resActions extends sfQuery {

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Metodo para listar el informe inf_ven_consol_cliente
     *
     * @param sfWebRequest $request
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            /* if (isset($request['estado'])) {
              if ($request['estado'] == 'false') {
              $estado = 0;
              } else {
              $estado = 1;
              }
              } else {
              $estado = 1;
              } */

            /*
             * Variables opcionales
             */
            
            //PUNTO DE VENTA

            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
            } else {
                $wherePuntoVenta = ' ';
            }

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * Formato de fecha sin time
             */
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

            CN_TABLE::executeSQL($sql);


            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            /*
              To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
              and Tab0.estado = $estado
              $whereTercero
             */
            $sql = <<<EOD

select count(*) as count from (

Select * From (

select tab0.*

from (

select

tab2.id_punto_venta AS ID_PUNTO_VENTA,
tab2.descripcion AS PV,
count(tab1.id_factura) AS CANTIDAD,
sum(NVL(tab1.valor_bruto,0)) AS VALOR_FACTURA,
sum(NVL(tab1.valor_iva,0)) AS IVA,
sum(NVL(tab1.valor_total,0)) AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1 and To_Char(tab1.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab1.estado=1
group by tab2.id_punto_venta,tab2.descripcion

UNION

select

tab5.id_punto_venta AS ID_PUNTO_VENTA,
tab5.descripcion AS PV,
count(tab4.id_debito) AS CANTIDAD,
sum(NVL(tab4.valor_bruto,0)) AS VALOR_FACTURA,
sum(NVL(tab4.valor_iva,0)) AS IVA,
sum(NVL(tab4.valor_total,0)) AS TOTAL


from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito in (1,3) and To_Char(tab4.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado = 1
group by tab5.id_punto_venta,tab5.descripcion

)tab0

where tab0.id_punto_venta is not null 
$wherePuntoVenta

)
)

EOD;




            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];





            //obtener el listado de recaudos
            //20170119 ticket CART-135 se actualizo la consulta para traer tambien las anuladas del periodo
            $sql = <<<EOD

SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select tab0.*

from (

select

tab2.id_punto_venta AS ID_PUNTO_VENTA,
tab2.descripcion AS PV,
count(tab1.id_factura) AS CANTIDAD,
sum(NVL(tab1.valor_bruto,0)) AS VALOR_FACTURA,
sum(NVL(tab1.valor_iva,0)) AS VALOR_IVA,
sum(NVL(tab1.valor_total,0)) AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1 and To_Char(tab1.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' 
group by tab2.id_punto_venta,tab2.descripcion

UNION

select

tab5.id_punto_venta AS ID_PUNTO_VENTA,
tab5.descripcion AS PV,
count(tab4.id_debito) AS CANTIDAD,
sum(NVL(tab4.valor_bruto,0)) AS VALOR_FACTURA,
sum(NVL(tab4.valor_iva,0)) AS IVA,
sum(NVL(tab4.valor_total,0)) AS TOTAL


from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito in (1,3) and To_Char(tab4.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' 
group by tab5.id_punto_venta,tab5.descripcion
                    
UNION

select
tab2.id_punto_venta AS ID_PUNTO_VENTA,
tab2.descripcion AS PV,
count(tab1.id_factura) AS CANTIDAD,
sum(NVL(tab1.valor_bruto,0))*-1 AS VALOR_FACTURA,
sum(NVL(tab1.valor_iva,0))*-1 AS IVA,
sum(NVL(tab1.valor_total,0))*-1 AS TOTAL

from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros_v tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

left join(
    select
    fac.id_factura,
    sum(fac.valor) as valor
    from ca_factura_pago fac
    group by
    fac.id_factura
)facpag
on facpag.id_factura = tab1.id_factura

where tab2.es_pos=1 and trunc(tab1.fecha_anu) BETWEEN TO_DATE('$fecha_ini' ,'YYYY-MM-DD') AND TO_DATE( '$fecha_fin' ,'YYYY-MM-DD') and tab1.estado=0
group by tab2.id_punto_venta,tab2.descripcion
UNION

select
tab5.id_punto_venta AS ID_PUNTO_VENTA,
tab5.descripcion AS PV,
count(tab4.id_debito) AS CANTIDAD,
sum(NVL(tab4.valor_bruto,0))*-1 AS VALOR_FACTURA,
sum(NVL(tab4.valor_iva,0))*-1 AS IVA,
sum(NVL(tab4.valor_total,0))*-1 AS TOTAL

from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros_v tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito in (1,3) and trunc(tab4.fecha_anu) BETWEEN TO_DATE('$fecha_ini' ,'YYYY-MM-DD') AND TO_DATE( '$fecha_fin' ,'YYYY-MM-DD') and tab4.estado=0
group by tab5.id_punto_venta,tab5.descripcion
)tab0

where tab0.id_punto_venta is not null 
$wherePuntoVenta    
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart

EOD;



            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow =  $this->startRow + count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar el informe inf_ven_consol_cliente
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            /* if (isset($request['estado'])) {
              if ($request['estado'] == 'false') {
              $estado = 0;
              } else {
              $estado = 1;
              }
              } else {
              $estado = 1;
              } */

            /*
             * Variables opcionales
             */
            
            //PUNTO DE VENTA

            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
            } else {
                $wherePuntoVenta = ' ';
            }


            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }


            //obtener el listado de recaudos
            //20170119 ticket CART-135 se actualizo la consulta para traer tambien las anuladas del periodo
            $sql = <<<EOD
SELECT 
    
count(*) as id_punto_venta, 
'TOTALES' as pv,

SUM(NVL(valor_factura,0)) as valor_factura, 
SUM(NVL(iva,0)) as valor_iva, 
SUM(NVL(total,0)) as total

FROM (


select tab0.*

from (

select

tab2.id_punto_venta AS ID_PUNTO_VENTA,
tab2.descripcion AS PV,
count(tab1.id_factura) AS CANTIDAD,
sum(NVL(tab1.valor_bruto,0)) AS VALOR_FACTURA,
sum(NVL(tab1.valor_iva,0)) AS IVA,
sum(NVL(tab1.valor_total,0)) AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1 and To_Char(tab1.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' 
group by tab2.id_punto_venta,tab2.descripcion

UNION

select

tab5.id_punto_venta AS ID_PUNTO_VENTA,
tab5.descripcion AS PV,
count(tab4.id_debito) AS CANTIDAD,
sum(NVL(tab4.valor_bruto,0)) AS VALOR_FACTURA,
sum(NVL(tab4.valor_iva,0)) AS IVA,
sum(NVL(tab4.valor_total,0)) AS TOTAL


from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito in (1,3) and To_Char(tab4.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' 
group by tab5.id_punto_venta,tab5.descripcion
                    
UNION

select
tab2.id_punto_venta AS ID_PUNTO_VENTA,
tab2.descripcion AS PV,
count(tab1.id_factura) AS CANTIDAD,
sum(NVL(tab1.valor_bruto,0))*-1 AS VALOR_FACTURA,
sum(NVL(tab1.valor_iva,0))*-1 AS IVA,
sum(NVL(tab1.valor_total,0))*-1 AS TOTAL

from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros_v tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

left join(
    select
    fac.id_factura,
    sum(fac.valor) as valor
    from ca_factura_pago fac
    group by
    fac.id_factura
)facpag
on facpag.id_factura = tab1.id_factura

where tab2.es_pos=1 and trunc(tab1.fecha_anu) BETWEEN TO_DATE('$fecha_ini' ,'YYYY-MM-DD') AND TO_DATE( '$fecha_fin' ,'YYYY-MM-DD') and tab1.estado=0
group by tab2.id_punto_venta,tab2.descripcion
UNION

select
tab5.id_punto_venta AS ID_PUNTO_VENTA,
tab5.descripcion AS PV,
count(tab4.id_debito) AS CANTIDAD,
sum(NVL(tab4.valor_bruto,0))*-1 AS VALOR_FACTURA,
sum(NVL(tab4.valor_iva,0))*-1 AS IVA,
sum(NVL(tab4.valor_total,0))*-1 AS TOTAL

from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros_v tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito in (1,3) and trunc(tab4.fecha_anu) BETWEEN TO_DATE('$fecha_ini' ,'YYYY-MM-DD') AND TO_DATE( '$fecha_fin' ,'YYYY-MM-DD') and tab4.estado=0
group by tab5.id_punto_venta,tab5.descripcion
)tab0

where tab0.id_punto_venta is not null 
$wherePuntoVenta
    
)
EOD;


            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
